;*---------------------------------------------------------------------*/
;*    Copyright (c) 1994 by Manuel Serrano. All rights reserved.       */
;*                                                                     */
;*                                     ,--^,                           */
;*                               _ ___/ /|/                            */
;*                           ,;'( )__, ) '                             */
;*                          ;;  //   L__.                              */
;*                          '   \    /  '                              */
;*                               ^   ^                                 */
;*                                                                     */
;*                                                                     */
;*    This program is distributed in the hope that it will be useful.  */
;*    Use and copying of this software and preparation of derivative   */
;*    works based upon this software are permitted, so long as the     */
;*    following conditions are met:                                    */
;*           o credit to the authors is acknowledged following         */
;*             current academic behaviour                              */
;*           o no fees or compensation are charged for use, copies,    */
;*             or access to this software                              */
;*           o this copyright notice is included intact.               */
;*      This software is made available AS IS, and no warranty is made */
;*      about the software or its performance.                         */
;*                                                                     */
;*      Bug descriptions, use reports, comments or suggestions are     */
;*      welcome Send them to                                           */
;*        <Manuel.Serrano@inria.fr>                                    */
;*        Manuel Serrano                                               */
;*        INRIA -- Rocquencourt                                        */
;*        Domaine de Voluceau, BP 105                                  */
;*        78153 Le Chesnay Cedex                                       */
;*        France                                                       */
;*---------------------------------------------------------------------*/


;; Le module                                                                 
(module
  __caml_front
  (foreign (include #"caml-bigloo.h"))
  (import
    (__caml_ty_error #"ty_error.scm")
    (__caml_builtins #"builtins.scm")
    (__caml_location #"location.scm")
    (__camli_location #"location.sci")
    (__caml_misc #"misc.scm")
    (__caml_tr_env #"tr_env.scm")
    (__caml_trstream #"trstream.scm")
    (__caml_match #"match.scm")
    (__caml_modules #"modules.scm")
    (__caml_syntax #"syntax.scm")
    (__caml_prim #"prim.scm")
    (__caml_lambda #"lambda.scm")
    (__caml_globals #"globals.scm")
    (__caml_const #"const.scm"))
  (export
    (extract_constant_30@front x1)
    (check_letrec_expr_190@front x1)
    (size_of_expr_51@front x1)
    (partial_fun_13@front x1)
    (2-100-partial_fun_13@front x1 x2)
    (partial_try_216@front x1)
    (translate_expr_56@front x1)
    (translate_let_249@front x1)
    (translate_match_88@front x1)
    (translate_bind_17@front x1)
    (translate_simple_match_49@front x1)
    (2-28-translate_expr_56@front x1 x3)
    (4-219-translate_match_88@front x1 x2 x3 x4)
    (4-190-translate_simple_match_49@front
      x1
      x2
      x3
      x4)
    (2-61-translate_let_249@front x1 x2)
    (2-150-translate_bind_17@front x1 x2)
    translate_expression_98@front
    (make_sequence_247@front x1)
    (2-56-make_sequence_247@front x1 x2)
    (translate_letdef_153@front x1)
    (2-223-translate_letdef_153@front x1 x2)
    (translate_letdef_rec_253@front x1)
    (2-231-translate_letdef_rec_253@front x1 x2)))
;; L'initialisation du module                                                
(init_camloo!)
;; Les variables globales                                                    
;; Les expressions globales                                                  
(define extract_constant_30@front
  (lambda (x1)
    (labels
      ((staticfail1000 () (raise 'not_constant_1@front)))
      (case (if (caml-constant-constr? x1)
              -1
              (caml-regular-constr-tag x1))
        ((2) (caml-constr-get-field x1 0))
        (else (staticfail1000))))))

(define check_letrec_expr_190@front
  (lambda (x1)
    (let ((x2 (caml-constr-get-field x1 0)))
      (labels
        ((staticfail1001
           ()
           (illegal_letrec_expr_66@ty_error
             (caml-constr-get-field x1 1))))
        (case (if (caml-constant-constr? x2)
                -1
                (caml-regular-constr-tag x2))
          ((22 23 8 4 2 1) (caml-make-tag 0 1))
          ((17 3)
           ((do_list_18@list check_letrec_expr_190@front)
            (caml-constr-get-field x2 0)))
          ((5)
           (begin
             (check_letrec_expr_190@front
               (caml-constr-get-field x2 1))
             (let ((x3 (caml-constr-get-field
                         (caml-constr-get-field
                           (caml-constr-get-field x2 0)
                           1)
                         4)))
               (labels
                 ((staticfail1002 () (caml-make-tag 0 1)))
                 (case (if (caml-constant-constr? x3)
                         -1
                         (caml-regular-constr-tag x3))
                   ((3)
                    (let ((x4 (caml-constr-get-field x2 1)))
                      (labels
                        ((staticfail1003
                           ()
                           (illegal_letrec_expr_66@ty_error
                             (caml-constr-get-field x1 1))))
                        (case (if (caml-constant-constr?
                                    (caml-constr-get-field x4 0))
                                -1
                                (caml-regular-constr-tag
                                  (caml-constr-get-field x4 0)))
                          ((3) (caml-make-tag 0 1))
                          (else (staticfail1003))))))
                   (else (staticfail1002)))))))
          ((16)
           (check_letrec_expr_190@front
             (caml-constr-get-field x2 0)))
          ((19)
           ((do_list_18@list
              (lambda (x3)
                (check_letrec_expr_190@front
                  (caml-constr-get-field x3 1))))
            (caml-constr-get-field x2 0)))
          (else (staticfail1001)))))))

(define size_of_expr_51@front
  (lambda (x1)
    (let ((x2 (caml-constr-get-field x1 0)))
      (labels
        ((staticfail1004
           ()
           (illegal_letrec_expr_66@ty_error
             (caml-constr-get-field x1 1))))
        (case (if (caml-constant-constr? x2)
                -1
                (caml-regular-constr-tag x2))
          ((3)
           (begin
             ((do_list_18@list check_letrec_expr_190@front)
              (caml-constr-get-field x2 0))
             (caml-make-regular
               (caml-make-tag 0 7)
               1
               (list_length_112@list
                 (caml-constr-get-field x2 0)))))
          ((5)
           (begin
             (check_letrec_expr_190@front
               (caml-constr-get-field x2 1))
             (let ((x3 (caml-constr-get-field
                         (caml-constr-get-field
                           (caml-constr-get-field x2 0)
                           1)
                         4)))
               (labels
                 ((staticfail1005
                    ()
                    (caml-make-regular
                      (caml-make-tag 1 7)
                      2
                      (caml-constr-get-field x2 0)
                      1)))
                 (case (if (caml-constant-constr? x3)
                         -1
                         (caml-regular-constr-tag x3))
                   ((3)
                    (caml-make-regular
                      (caml-make-tag 1 7)
                      2
                      (caml-constr-get-field x2 0)
                      (caml-constr-get-field x3 0)))
                   (else (staticfail1005)))))))
          ((8) (caml-make-tag 2 7))
          ((16)
           (size_of_expr_51@front
             (caml-constr-get-field x2 0)))
          ((17)
           (begin
             ((do_list_18@list check_letrec_expr_190@front)
              (caml-constr-get-field x2 0))
             (caml-make-regular
               (caml-make-tag 3 7)
               1
               (list_length_112@list
                 (caml-constr-get-field x2 0)))))
          ((19)
           (begin
             ((do_list_18@list
                (lambda (x3)
                  (check_letrec_expr_190@front
                    (caml-constr-get-field x3 1))))
              (caml-constr-get-field x2 0))
             (caml-make-regular
               (caml-make-tag 4 7)
               1
               (list_length_112@list
                 (caml-constr-get-field x2 0)))))
          ((7)
           (begin
             ((do_list_18@list
                (lambda (x3)
                  (check_letrec_expr_190@front
                    (caml-constr-get-field x3 1))))
              (caml-constr-get-field x2 1))
             (size_of_expr_51@front
               (caml-constr-get-field x2 2))))
          ((22) (caml-make-tag 5 7))
          ((23) (caml-make-tag 6 7))
          (else (staticfail1004)))))))

(begin
  (define partial_fun_13@front
    (lambda (x1)
      (lambda (x2) (2-100-partial_fun_13@front x1 x2))))
 (define 2-100-partial_fun_13@front
    (lambda (x1 x2)
      (let ((x3 (caml-make-regular
                  (caml-make-tag 6 19)
                  2
                  (caml-make-tag 11 38)
                  (cons (caml-make-regular
                          (caml-make-tag 1 19)
                          1
                          (caml-make-regular
                            (caml-make-tag 1 2)
                            2
                            match_failure_tag_73@builtins
                            (cons (caml-make-regular
                                    (caml-make-tag 0 2)
                                    1
                                    (caml-make-regular
                                      (caml-make-tag 2 4)
                                      1
                                      (cell-ref input_name_202@location)))
                                  (cons (caml-make-regular
                                          (caml-make-tag 0 2)
                                          1
                                          (caml-make-regular
                                            (caml-make-tag 0 4)
                                            1
                                            (caml-constr-get-field x1 0)))
                                        (cons (caml-make-regular
                                                (caml-make-tag 0 2)
                                                1
                                                (caml-make-regular
                                                  (caml-make-tag 0 4)
                                                  1
                                                  (caml-constr-get-field x1 1)))
                                              '())))))
                        '()))))
        (let ((x4 x2))
          (labels
            ((staticfail1006 () x3))
            (let ((:-d.1007 x4))
              (cond ((eq? :-d.1007 (caml-make-tag 2 3))
                     (begin
                       (prerr_location_1@location x1)
                       (begin
                         (prerr_begline_213@misc
                           #" Warning: pattern matching is not exhaustive")
                         (begin (prerr_endline2_160@misc #"") x3))))
                    (else (staticfail1006)))))))))
)
(define partial_try_216@front
  (lambda (x1)
    (caml-make-regular
      (caml-make-tag 6 19)
      2
      (caml-make-tag 11 38)
      (cons (caml-make-regular (caml-make-tag 0 19) 1 0)
            '()))))

(begin
  (begin
    (define translate_expr_56@front
      (lambda (x1)
        (lambda (x3)
          (2-28-translate_expr_56@front x1 x3))))
   (define 2-28-translate_expr_56@front
      (lambda (x1 x3)
        (letrec ((x2 (lambda (x3)
                       (let ((x4 (caml-constr-get-field x3 0)))
                         (case (caml-regular-constr-tag x4)
                           ((1)
                            (case (caml-regular-constr-tag
                                    (cell-ref (caml-constr-get-field x4 0)))
                              ((2)
                               (let ((x5 (caml-constr-get-field
                                           (cell-ref
                                             (caml-constr-get-field x4 0))
                                           0)))
                                 ((translate_access_117@tr_env x5) x1)))
                              (else
                               (let ((x5 (caml-constr-get-field
                                           (cell-ref
                                             (caml-constr-get-field x4 0))
                                           0)))
                                 (let ((x6 (caml-constr-get-field
                                             (caml-constr-get-field x5 1)
                                             1)))
                                   (let ((:-d.1008 x6))
                                     (cond ((eq? :-d.1008 (caml-make-tag 0 2))
                                            (caml-make-regular
                                              (caml-make-tag 6 19)
                                              2
                                              (caml-make-regular
                                                (caml-make-tag 1 38)
                                                1
                                                (caml-constr-get-field x5 0))
                                              '()))
                                           (else
                                            (labels
                                              ((staticfail1009
                                                 ()
                                                 (letrec ((x7 (lambda (x8)
                                                                (lambda (x9)
                                                                  (if (>=fx x9
                                                                            (caml-constr-get-field
                                                                              x6
                                                                              0))
                                                                    (caml-make-regular
                                                                      (caml-make-tag
                                                                        6
                                                                        19)
                                                                      2
                                                                      (caml-constr-get-field
                                                                        x6
                                                                        1)
                                                                      x8)
                                                                    (caml-make-regular
                                                                      (caml-make-tag
                                                                        3
                                                                        19)
                                                                      1
                                                                      ((x7 (cons (caml-make-regular
                                                                                   (caml-make-tag
                                                                                     0
                                                                                     19)
                                                                                   1
                                                                                   x9)
                                                                                 x8))
                                                                       (+fx x9
                                                                            1))))))))
                                                   ((x7 '()) 0))))
                                              (let ((:-d.1010
                                                      (caml-constr-get-field
                                                        x6
                                                        0)))
                                                (cond ((=fx :-d.1010 0)
                                                       (caml-make-regular
                                                         (caml-make-tag 6 19)
                                                         2
                                                         (caml-make-regular
                                                           (caml-make-tag 1 38)
                                                           1
                                                           (caml-constr-get-field
                                                             x5
                                                             0))
                                                         '()))
                                                      (else
                                                       (staticfail1009)))))))))))))
                           ((2)
                            (caml-make-regular
                              (caml-make-tag 1 19)
                              1
                              (caml-constr-get-field x4 0)))
                           ((3)
                            (let ((x5 ((map_118@list x2)
                                       (caml-constr-get-field x4 0))))
                              (let* ((handler-top1012 current_handler)
                                     (:-d.1013 (unspecified)))
                                (labels
                                  ((try1014
                                     (:-d.1013)
                                     (begin
                                       (get-the-continuation :-d.1013)
                                       (if (eq? #t #f)
                                         (try1014 (try1014 (try1014 1))))
                                       (if :-d.1013
                                         (caml-make-regular
                                           (caml-make-tag 1 19)
                                           1
                                           (caml-make-regular
                                             (caml-make-tag 1 2)
                                             2
                                             (caml-make-regular
                                               (caml-make-tag 1 2)
                                               3
                                               (caml-make-regular
                                                 (caml-make-tag 0 0)
                                                 2
                                                 #"builtin"
                                                 #"tuple")
                                               0
                                               1)
                                             ((map_118@list
                                                extract_constant_30@front)
                                              x5)))
                                         current_handler))))
                                  (let ((x6 (try1014 :-d.1013)))
                                    (set! current_handler handler-top1012)
                                    (if (=fx *try* 1)
                                      (begin
                                        (set! *try* 0)
                                        (labels
                                          ((staticfail1015 () (raise x6)))
                                          (case (caml-extensible-constr-tag x6)
                                            ((not_constant_1@front)
                                             (caml-make-regular
                                               (caml-make-tag 6 19)
                                               2
                                               (caml-make-regular
                                                 (caml-make-tag 6 38)
                                                 1
                                                 (caml-make-regular
                                                   (caml-make-tag 1 2)
                                                   3
                                                   (caml-make-regular
                                                     (caml-make-tag 0 0)
                                                     2
                                                     #"builtin"
                                                     #"tuple")
                                                   0
                                                   1))
                                               x5))
                                            (else (staticfail1015)))))
                                      x6))))))
                           ((4)
                            (caml-make-regular
                              (caml-make-tag 1 19)
                              1
                              (caml-make-regular
                                (caml-make-tag 1 2)
                                2
                                (caml-constr-get-field
                                  (caml-constr-get-field
                                    (caml-constr-get-field x4 0)
                                    1)
                                  3)
                                '())))
                           ((5)
                            (let ((x5 (caml-constr-get-field
                                        (caml-constr-get-field
                                          (caml-constr-get-field x4 0)
                                          1)
                                        4)))
                              (let ((:-d.1016 x5))
                                (cond ((eq? :-d.1016 (caml-make-tag 0 3))
                                       (caml-make-regular
                                         (caml-make-tag 13 19)
                                         2
                                         (x2 (caml-constr-get-field x4 1))
                                         (caml-make-regular
                                           (caml-make-tag 1 19)
                                           1
                                           (caml-make-regular
                                             (caml-make-tag 1 2)
                                             2
                                             (caml-constr-get-field
                                               (caml-constr-get-field
                                                 (caml-constr-get-field x4 0)
                                                 1)
                                               3)
                                             '()))))
                                      ((eq? :-d.1016 (caml-make-tag 1 3))
                                       (let ((x6 (x2 (caml-constr-get-field
                                                       x4
                                                       1))))
                                         (let ((x7 (caml-constr-get-field
                                                     (caml-constr-get-field
                                                       (caml-constr-get-field
                                                         x4
                                                         0)
                                                       1)
                                                     2)))
                                           (let ((:-d.1017 x7))
                                             (cond ((eq? :-d.1017
                                                         (caml-make-tag 0 2))
                                                    (caml-make-regular
                                                      (caml-make-tag 6 19)
                                                      2
                                                      (caml-make-regular
                                                        (caml-make-tag 6 38)
                                                        1
                                                        (caml-constr-get-field
                                                          (caml-constr-get-field
                                                            (caml-constr-get-field
                                                              x4
                                                              0)
                                                            1)
                                                          3))
                                                      (cons x6 '())))
                                                   ((eq? :-d.1017
                                                         (caml-make-tag 1 2))
                                                    (let* ((handler-top1019
                                                             current_handler)
                                                           (:-d.1020
                                                             (unspecified)))
                                                      (labels
                                                        ((try1021
                                                           (:-d.1020)
                                                           (begin
                                                             (get-the-continuation
                                                               :-d.1020)
                                                             (if (eq? #t #f)
                                                               (try1021
                                                                 (try1021
                                                                   (try1021
                                                                     1))))
                                                             (if :-d.1020
                                                               (caml-make-regular
                                                                 (caml-make-tag
                                                                   1
                                                                   19)
                                                                 1
                                                                 (caml-make-regular
                                                                   (caml-make-tag
                                                                     1
                                                                     2)
                                                                   2
                                                                   (caml-constr-get-field
                                                                     (caml-constr-get-field
                                                                       (caml-constr-get-field
                                                                         x4
                                                                         0)
                                                                       1)
                                                                     3)
                                                                   (cons (extract_constant_30@front
                                                                           x6)
                                                                         '())))
                                                               current_handler))))
                                                        (let ((x8 (try1021
                                                                    :-d.1020)))
                                                          (set! current_handler
                                                            handler-top1019)
                                                          (if (=fx *try* 1)
                                                            (begin
                                                              (set! *try* 0)
                                                              (labels
                                                                ((staticfail1022
                                                                   ()
                                                                   (raise x8)))
                                                                (case (caml-extensible-constr-tag
                                                                        x8)
                                                                  ((not_constant_1@front)
                                                                   (caml-make-regular
                                                                     (caml-make-tag
                                                                       6
                                                                       19)
                                                                     2
                                                                     (caml-make-regular
                                                                       (caml-make-tag
                                                                         6
                                                                         38)
                                                                       1
                                                                       (caml-constr-get-field
                                                                         (caml-constr-get-field
                                                                           (caml-constr-get-field
                                                                             x4
                                                                             0)
                                                                           1)
                                                                         3))
                                                                     (cons x6
                                                                           '())))
                                                                  (else
                                                                   (staticfail1022)))))
                                                            x8)))))
                                                   (else #f))))))
                                      (else
                                       (let ((x6 (caml-constr-get-field x4 1)))
                                         (labels
                                           ((staticfail1023
                                              ()
                                              (letrec ((x7 (lambda (x8)
                                                             (if (>=fx x8
                                                                       (caml-constr-get-field
                                                                         x5
                                                                         0))
                                                               '()
                                                               (cons (caml-make-regular
                                                                       (caml-make-tag
                                                                         6
                                                                         19)
                                                                       2
                                                                       (caml-make-regular
                                                                         (caml-make-tag
                                                                           8
                                                                           38)
                                                                         1
                                                                         x8)
                                                                       (cons (caml-make-regular
                                                                               (caml-make-tag
                                                                                 0
                                                                                 19)
                                                                               1
                                                                               0)
                                                                             '()))
                                                                     (x7 (+fx x8
                                                                              1)))))))
                                                (caml-make-regular
                                                  (caml-make-tag 4 19)
                                                  2
                                                  (cons (x2 (caml-constr-get-field
                                                              x4
                                                              1))
                                                        '())
                                                  (caml-make-regular
                                                    (caml-make-tag 6 19)
                                                    2
                                                    (caml-make-regular
                                                      (caml-make-tag 6 38)
                                                      1
                                                      (caml-constr-get-field
                                                        (caml-constr-get-field
                                                          (caml-constr-get-field
                                                            x4
                                                            0)
                                                          1)
                                                        3))
                                                    (x7 0))))))
                                           (case (if (caml-constant-constr?
                                                       (caml-constr-get-field
                                                         x6
                                                         0))
                                                   -1
                                                   (caml-regular-constr-tag
                                                     (caml-constr-get-field
                                                       x6
                                                       0)))
                                             ((3)
                                              (let ((x7 ((map_118@list x2)
                                                         (caml-constr-get-field
                                                           (caml-constr-get-field
                                                             x6
                                                             0)
                                                           0))))
                                                (let* ((handler-top1025
                                                         current_handler)
                                                       (:-d.1026 (unspecified)))
                                                  (labels
                                                    ((try1027
                                                       (:-d.1026)
                                                       (begin
                                                         (get-the-continuation
                                                           :-d.1026)
                                                         (if (eq? #t #f)
                                                           (try1027
                                                             (try1027
                                                               (try1027 1))))
                                                         (if :-d.1026
                                                           (caml-make-regular
                                                             (caml-make-tag
                                                               1
                                                               19)
                                                             1
                                                             (caml-make-regular
                                                               (caml-make-tag
                                                                 1
                                                                 2)
                                                               2
                                                               (caml-constr-get-field
                                                                 (caml-constr-get-field
                                                                   (caml-constr-get-field
                                                                     x4
                                                                     0)
                                                                   1)
                                                                 3)
                                                               ((map_118@list
                                                                  extract_constant_30@front)
                                                                x7)))
                                                           current_handler))))
                                                    (let ((x8 (try1027
                                                                :-d.1026)))
                                                      (set! current_handler
                                                        handler-top1025)
                                                      (if (=fx *try* 1)
                                                        (begin
                                                          (set! *try* 0)
                                                          (labels
                                                            ((staticfail1028
                                                               ()
                                                               (raise x8)))
                                                            (case (caml-extensible-constr-tag
                                                                    x8)
                                                              ((not_constant_1@front)
                                                               (caml-make-regular
                                                                 (caml-make-tag
                                                                   6
                                                                   19)
                                                                 2
                                                                 (caml-make-regular
                                                                   (caml-make-tag
                                                                     6
                                                                     38)
                                                                   1
                                                                   (caml-constr-get-field
                                                                     (caml-constr-get-field
                                                                       (caml-constr-get-field
                                                                         x4
                                                                         0)
                                                                       1)
                                                                     3))
                                                                 x7))
                                                              (else
                                                               (staticfail1028)))))
                                                        x8))))))
                                             (else (staticfail1023))))))))))
                           ((6)
                            (labels
                              ((staticfail1029
                                 ()
                                 (caml-make-regular
                                   (caml-make-tag 2 19)
                                   2
                                   (x2 (caml-constr-get-field x4 0))
                                   ((map_118@list x2)
                                    (caml-constr-get-field x4 1)))))
                              (case (if (caml-constant-constr?
                                          (caml-constr-get-field
                                            (caml-constr-get-field x4 0)
                                            0))
                                      -1
                                      (caml-regular-constr-tag
                                        (caml-constr-get-field
                                          (caml-constr-get-field x4 0)
                                          0)))
                                ((8)
                                 (if (null? (caml-constr-get-field
                                              (caml-constr-get-field
                                                (caml-constr-get-field x4 0)
                                                0)
                                              0))
                                   (staticfail1029)
                                   (if (eq? (list_length_112@list
                                              (caml-constr-get-field
                                                (car (caml-constr-get-field
                                                       (caml-constr-get-field
                                                         (caml-constr-get-field
                                                           x4
                                                           0)
                                                         0)
                                                       0))
                                                0))
                                            (list_length_112@list
                                              (caml-constr-get-field x4 1)))
                                     (caml-make-regular
                                       (caml-make-tag 4 19)
                                       2
                                       ((translate_let_249@front x1)
                                        (caml-constr-get-field x4 1))
                                       ((((translate_match_88@front
                                            (caml-constr-get-field x3 1))
                                          x1)
                                         (partial_fun_13@front
                                           (caml-constr-get-field x3 1)))
                                        (caml-constr-get-field
                                          (caml-constr-get-field
                                            (caml-constr-get-field x4 0)
                                            0)
                                          0)))
                                     (caml-make-regular
                                       (caml-make-tag 2 19)
                                       2
                                       (x2 (caml-constr-get-field x4 0))
                                       ((map_118@list x2)
                                        (caml-constr-get-field x4 1))))))
                                ((1)
                                 (case (if (caml-constant-constr?
                                             (cell-ref
                                               (caml-constr-get-field
                                                 (caml-constr-get-field
                                                   (caml-constr-get-field x4 0)
                                                   0)
                                                 0)))
                                         -1
                                         (caml-regular-constr-tag
                                           (cell-ref
                                             (caml-constr-get-field
                                               (caml-constr-get-field
                                                 (caml-constr-get-field x4 0)
                                                 0)
                                               0))))
                                   ((1)
                                    (let ((x5 (caml-constr-get-field
                                                (cell-ref
                                                  (caml-constr-get-field
                                                    (caml-constr-get-field
                                                      (caml-constr-get-field
                                                        x4
                                                        0)
                                                      0)
                                                    0))
                                                0)))
                                      (let ((x6 (caml-constr-get-field
                                                  (caml-constr-get-field x5 1)
                                                  1)))
                                        (let ((:-d.1030 x6))
                                          (cond ((eq? :-d.1030
                                                      (caml-make-tag 0 2))
                                                 (caml-make-regular
                                                   (caml-make-tag 2 19)
                                                   2
                                                   (x2 (caml-constr-get-field
                                                         x4
                                                         0))
                                                   ((map_118@list x2)
                                                    (caml-constr-get-field
                                                      x4
                                                      1))))
                                                (else
                                                 (if (eq? (caml-constr-get-field
                                                            x6
                                                            0)
                                                          (list_length_112@list
                                                            (caml-constr-get-field
                                                              x4
                                                              1)))
                                                   (caml-make-regular
                                                     (caml-make-tag 6 19)
                                                     2
                                                     (caml-constr-get-field
                                                       x6
                                                       1)
                                                     ((map_118@list x2)
                                                      (caml-constr-get-field
                                                        x4
                                                        1)))
                                                   (caml-make-regular
                                                     (caml-make-tag 2 19)
                                                     2
                                                     (x2 (caml-constr-get-field
                                                           x4
                                                           0))
                                                     ((map_118@list x2)
                                                      (caml-constr-get-field
                                                        x4
                                                        1))))))))))
                                   (else (staticfail1029))))
                                (else (staticfail1029)))))
                           ((7)
                            (let ((:-d.1031 (caml-constr-get-field x4 0)))
                              (cond ((eq? :-d.1031 (caml-make-tag 0 2))
                                     (let ((x5 ((map_118@list
                                                  (lambda (x5)
                                                    (caml-constr-get-field
                                                      x5
                                                      0)))
                                                (caml-constr-get-field x4 1))))
                                       (caml-make-regular
                                         (caml-make-tag 4 19)
                                         2
                                         ((translate_bind_17@front x1)
                                          (caml-constr-get-field x4 1))
                                         ((((translate_match_88@front
                                              (caml-constr-get-field x3 1))
                                            x1)
                                           (partial_fun_13@front
                                             (caml-constr-get-field x3 1)))
                                          (cons (caml-make-regular
                                                  (caml-make-tag 0 1)
                                                  2
                                                  x5
                                                  (caml-constr-get-field x4 2))
                                                '())))))
                                    ((eq? :-d.1031 (caml-make-tag 1 2))
                                     (let ((x5 ((add_let_rec_to_env_158@tr_env
                                                  x1)
                                                (caml-constr-get-field x4 1))))
                                       (let ((x6 (lambda (x6)
                                                   (labels
                                                     ((staticfail1032
                                                        ()
                                                        (fatal_error_193@misc
                                                          #"translate_rec_bind")))
                                                     (case (if (caml-constant-constr?
                                                                 (caml-constr-get-field
                                                                   (caml-constr-get-field
                                                                     x6
                                                                     0)
                                                                   0))
                                                             -1
                                                             (caml-regular-constr-tag
                                                               (caml-constr-get-field
                                                                 (caml-constr-get-field
                                                                   x6
                                                                   0)
                                                                 0)))
                                                       ((2)
                                                        (caml-make-regular
                                                          (caml-make-tag 0 1)
                                                          2
                                                          ((translate_expr_56@front
                                                             x5)
                                                           (caml-constr-get-field
                                                             x6
                                                             1))
                                                          (size_of_expr_51@front
                                                            (caml-constr-get-field
                                                              x6
                                                              1))))
                                                       (else
                                                        (staticfail1032)))))))
                                         (caml-make-regular
                                           (caml-make-tag 5 19)
                                           2
                                           ((map_118@list x6)
                                            (caml-constr-get-field x4 1))
                                           ((translate_expr_56@front x5)
                                            (caml-constr-get-field x4 2))))))
                                    (else #f))))
                           ((8)
                            (if (null? (caml-constr-get-field x4 0))
                              (fatal_error_193@misc
                                #"translate_expr: empty fun")
                              (letrec ((x5 (lambda (x6)
                                             (if (null? x6)
                                               ((((translate_match_88@front
                                                    (caml-constr-get-field
                                                      x3
                                                      1))
                                                  x1)
                                                 (partial_fun_13@front
                                                   (caml-constr-get-field
                                                     x3
                                                     1)))
                                                (caml-constr-get-field x4 0))
                                               (caml-make-regular
                                                 (caml-make-tag 3 19)
                                                 1
                                                 (x5 (cdr x6)))))))
                                (x5 (caml-constr-get-field
                                      (car (caml-constr-get-field x4 0))
                                      0)))))
                           ((9)
                            (caml-make-regular
                              (caml-make-tag 11 19)
                              2
                              (x2 (caml-constr-get-field x4 0))
                              ((((translate_simple_match_49@front
                                   (caml-constr-get-field x3 1))
                                 x1)
                                partial_try_216@front)
                               (caml-constr-get-field x4 1))))
                           ((10)
                            (caml-make-regular
                              (caml-make-tag 13 19)
                              2
                              (x2 (caml-constr-get-field x4 0))
                              (x2 (caml-constr-get-field x4 1))))
                           ((11)
                            (caml-make-regular
                              (caml-make-tag 12 19)
                              3
                              (x2 (caml-constr-get-field x4 0))
                              (x2 (caml-constr-get-field x4 1))
                              (x2 (caml-constr-get-field x4 2))))
                           ((12)
                            (caml-make-regular
                              (caml-make-tag 14 19)
                              2
                              (x2 (caml-constr-get-field x4 0))
                              (x2 (caml-constr-get-field x4 1))))
                           ((13)
                            (caml-make-regular
                              (caml-make-tag 15 19)
                              4
                              (x2 (caml-constr-get-field x4 1))
                              ((translate_expr_56@front
                                 (caml-make-regular (caml-make-tag 1 3) 1 x1))
                               (caml-constr-get-field x4 2))
                              (caml-constr-get-field x4 3)
                              ((translate_expr_56@front
                                 ((add_for_parameter_to_env_127@tr_env x1)
                                  (caml-constr-get-field x4 0)))
                               (caml-constr-get-field x4 4))))
                           ((14)
                            (caml-make-regular
                              (caml-make-tag 16 19)
                              2
                              (x2 (caml-constr-get-field x4 0))
                              (x2 (caml-constr-get-field x4 1))))
                           ((15)
                            (caml-make-regular
                              (caml-make-tag 17 19)
                              2
                              (x2 (caml-constr-get-field x4 0))
                              (x2 (caml-constr-get-field x4 1))))
                           ((16) (x2 (caml-constr-get-field x4 0)))
                           ((17)
                            (labels
                              ((staticfail1033
                                 ()
                                 (caml-make-regular
                                   (caml-make-tag 6 19)
                                   2
                                   (caml-make-regular
                                     (caml-make-tag 6 38)
                                     1
                                     (caml-make-regular
                                       (caml-make-tag 1 2)
                                       3
                                       (caml-make-regular
                                         (caml-make-tag 0 0)
                                         2
                                         #"builtin"
                                         #"vector")
                                       0
                                       0))
                                   ((map_118@list x2)
                                    (caml-constr-get-field x4 0)))))
                              (if (null? (caml-constr-get-field x4 0))
                                (caml-make-regular
                                  (caml-make-tag 1 19)
                                  1
                                  (caml-make-regular
                                    (caml-make-tag 1 2)
                                    2
                                    (caml-make-regular
                                      (caml-make-tag 1 2)
                                      3
                                      (caml-make-regular
                                        (caml-make-tag 0 0)
                                        2
                                        #"builtin"
                                        #"vector")
                                      0
                                      0)
                                    '()))
                                (staticfail1033))))
                           ((18)
                            (((translate_update_202@tr_env
                                (caml-constr-get-field x4 0))
                              x1)
                             (x2 (caml-constr-get-field x4 1))))
                           ((19)
                            (let ((x5 (make-vector
                                        (list_length_112@list
                                          (caml-constr-get-field x4 0))
                                        (caml-make-tag 9 19))))
                              (begin
                                ((do_list_18@list
                                   (lambda (x6)
                                     (vector-set!
                                       x5
                                       (caml-constr-get-field
                                         (caml-constr-get-field
                                           (caml-constr-get-field x6 0)
                                           1)
                                         3)
                                       (x2 (caml-constr-get-field x6 1)))))
                                 (caml-constr-get-field x4 0))
                                (let* ((handler-top1035 current_handler)
                                       (:-d.1036 (unspecified)))
                                  (labels
                                    ((try1037
                                       (:-d.1036)
                                       (begin
                                         (get-the-continuation :-d.1036)
                                         (if (eq? #t #f)
                                           (try1037 (try1037 (try1037 1))))
                                         (if :-d.1036
                                           (if ((for_all_96@list
                                                  (lambda (x6)
                                                    (eq? (caml-constr-get-field
                                                           (caml-constr-get-field
                                                             (caml-constr-get-field
                                                               x6
                                                               0)
                                                             1)
                                                           2)
                                                         (caml-make-tag 1 2))))
                                                (caml-constr-get-field x4 0))
                                             (caml-make-regular
                                               (caml-make-tag 1 19)
                                               1
                                               (caml-make-regular
                                                 (caml-make-tag 1 2)
                                                 2
                                                 (caml-make-regular
                                                   (caml-make-tag 1 2)
                                                   3
                                                   (caml-make-regular
                                                     (caml-make-tag 0 0)
                                                     2
                                                     #"builtin"
                                                     #"record")
                                                   0
                                                   0)
                                                 ((map_vect_list_65@fvect
                                                    extract_constant_30@front)
                                                  x5)))
                                             (raise 'not_constant_1@front))
                                           current_handler))))
                                    (let ((x6 (try1037 :-d.1036)))
                                      (set! current_handler handler-top1035)
                                      (if (=fx *try* 1)
                                        (begin
                                          (set! *try* 0)
                                          (labels
                                            ((staticfail1038 () (raise x6)))
                                            (case (caml-extensible-constr-tag
                                                    x6)
                                              ((not_constant_1@front)
                                               (caml-make-regular
                                                 (caml-make-tag 6 19)
                                                 2
                                                 (caml-make-regular
                                                   (caml-make-tag 6 38)
                                                   1
                                                   (caml-make-regular
                                                     (caml-make-tag 1 2)
                                                     3
                                                     (caml-make-regular
                                                       (caml-make-tag 0 0)
                                                       2
                                                       #"builtin"
                                                       #"record")
                                                     0
                                                     0))
                                                 (list_of_vect_3@fvect x5)))
                                              (else (staticfail1038)))))
                                        x6)))))))
                           ((20)
                            (caml-make-regular
                              (caml-make-tag 6 19)
                              2
                              (caml-make-regular
                                (caml-make-tag 8 38)
                                1
                                (caml-constr-get-field
                                  (caml-constr-get-field
                                    (caml-constr-get-field x4 1)
                                    1)
                                  3))
                              (cons (x2 (caml-constr-get-field x4 0)) '())))
                           ((21)
                            (caml-make-regular
                              (caml-make-tag 6 19)
                              2
                              (caml-make-regular
                                (caml-make-tag 9 38)
                                1
                                (caml-constr-get-field
                                  (caml-constr-get-field
                                    (caml-constr-get-field x4 1)
                                    1)
                                  3))
                              (cons (x2 (caml-constr-get-field x4 0))
                                    (cons (x2 (caml-constr-get-field x4 2))
                                          '()))))
                           ((22)
                            (((translate_stream_2@trstream
                                translate_expr_56@front)
                              x1)
                             (caml-constr-get-field x4 0)))
                           (else
                            ((((translate_parser_248@trstream
                                 translate_expr_56@front)
                               (caml-constr-get-field x3 1))
                              x1)
                             (caml-constr-get-field x4 0))))))))
          (x2 x3))))
)(begin
    (begin
      (define translate_match_88@front
        (lambda (x1)
          (lambda (x2)
            (lambda (x3)
              (lambda (x4)
                (4-219-translate_match_88@front x1 x2 x3 x4))))))
     (define 4-219-translate_match_88@front
        (lambda (x1 x2 x3 x4)
          (let ((x5 (lambda (x5)
                      (let ((x6 ((add_pat_list_to_env_65@tr_env x2)
                                 (caml-constr-get-field x5 0))))
                        (caml-make-regular
                          (caml-make-tag 0 1)
                          2
                          (caml-constr-get-field x5 0)
                          ((caml-constr-get-field x6 1)
                           ((translate_expr_56@front
                              (caml-constr-get-field x6 0))
                            (caml-constr-get-field x5 1))))))))
            (((translate_matching_84@match x3) x1)
             ((map_118@list x5) x4)))))
)  (begin
      (begin
        (define translate_simple_match_49@front
          (lambda (x1)
            (lambda (x2)
              (lambda (x3)
                (lambda (x4)
                  (4-190-translate_simple_match_49@front
                    x1
                    x2
                    x3
                    x4))))))
       (define 4-190-translate_simple_match_49@front
          (lambda (x1 x2 x3 x4)
            (let ((x5 (lambda (x5)
                        (let ((x6 ((add_pat_to_env_200@tr_env x2)
                                   (caml-constr-get-field x5 0))))
                          (caml-make-regular
                            (caml-make-tag 0 1)
                            2
                            (cons (caml-constr-get-field x5 0) '())
                            ((caml-constr-get-field x6 1)
                             ((translate_expr_56@front
                                (caml-constr-get-field x6 0))
                              (caml-constr-get-field x5 1))))))))
              (((translate_matching_84@match x3) x1)
               ((map_118@list x5) x4)))))
)    (begin
        (begin
          (define translate_let_249@front
            (lambda (x1)
              (lambda (x2)
                (2-61-translate_let_249@front x1 x2))))
         (define 2-61-translate_let_249@front
            (lambda (x1 x2)
              (if (null? x2)
                '()
                (cons ((translate_expr_56@front x1) (car x2))
                      ((translate_let_249@front
                         (caml-make-regular (caml-make-tag 1 3) 1 x1))
                       (cdr x2))))))
)      (begin
          (define translate_bind_17@front
            (lambda (x1)
              (lambda (x2)
                (2-150-translate_bind_17@front x1 x2))))
         (define 2-150-translate_bind_17@front
            (lambda (x1 x2)
              (if (null? x2)
                '()
                (cons ((translate_expr_56@front x1)
                       (caml-constr-get-field (car x2) 1))
                      ((translate_bind_17@front
                         (caml-make-regular (caml-make-tag 1 3) 1 x1))
                       (cdr x2))))))
)))))
(define translate_expression_98@front
  (translate_expr_56@front (caml-make-tag 0 3)))

(begin
  (define make_sequence_247@front
    (lambda (x1)
      (lambda (x2)
        (2-56-make_sequence_247@front x1 x2))))
 (define 2-56-make_sequence_247@front
    (lambda (x1 x2)
      (if (null? x2)
        (caml-make-regular
          (caml-make-tag 1 19)
          1
          (caml-make-regular
            (caml-make-tag 0 2)
            1
            (caml-make-regular (caml-make-tag 0 4) 1 0)))
        (labels
          ((staticfail1039
             ()
             (caml-make-regular
               (caml-make-tag 13 19)
               2
               (x1 (car x2))
               ((make_sequence_247@front x1) (cdr x2)))))
          (if (null? (cdr x2))
            (x1 (car x2))
            (staticfail1039))))))
)
(begin
  (define translate_letdef_153@front
    (lambda (x1)
      (lambda (x2)
        (2-223-translate_letdef_153@front x1 x2))))
 (define 2-223-translate_letdef_153@front
    (lambda (x1 x2)
      (let ((x3 (caml-constr-get-field
                  (cell-ref defined_module_128@modules)
                  0)))
        (let ((x4 x2))
          (labels
            ((staticfail1040
               ()
               (let ((x5 ((map_118@list
                            (lambda (x5) (caml-constr-get-field x5 0)))
                          x2)))
                 (let ((x6 ((flat_map_45@list free_vars_of_pat_1@syntax) x5)))
                   (let ((x7 (env_for_toplevel_let_34@tr_env x5)))
                     (let ((x8 (lambda (x8)
                                 (caml-make-regular
                                   (caml-make-tag 6 19)
                                   2
                                   (caml-make-regular
                                     (caml-make-tag 2 38)
                                     1
                                     (caml-make-regular
                                       (caml-make-tag 0 0)
                                       2
                                       x3
                                       x8))
                                   (cons ((translate_access_117@tr_env x8) x7)
                                         '())))))
                       (caml-make-regular
                         (caml-make-tag 4 19)
                         2
                         ((translate_bind_17@front (caml-make-tag 0 3))
                          x2)
                         (((translate_matching_84@match
                             (partial_fun_13@front x1))
                           x1)
                          (cons (caml-make-regular
                                  (caml-make-tag 0 1)
                                  2
                                  x5
                                  ((make_sequence_247@front x8) x6))
                                '())))))))))
            (if (null? x4)
              (staticfail1040)
              (case (if (caml-constant-constr?
                          (caml-constr-get-field
                            (caml-constr-get-field (car x4) 0)
                            0))
                      -1
                      (caml-regular-constr-tag
                        (caml-constr-get-field
                          (caml-constr-get-field (car x4) 0)
                          0)))
                ((2)
                 (if (null? (cdr x4))
                   (caml-make-regular
                     (caml-make-tag 6 19)
                     2
                     (caml-make-regular
                       (caml-make-tag 2 38)
                       1
                       (caml-make-regular
                         (caml-make-tag 0 0)
                         2
                         x3
                         (caml-constr-get-field
                           (caml-constr-get-field
                             (caml-constr-get-field (car x4) 0)
                             0)
                           0)))
                     (cons (translate_expression_98@front
                             (caml-constr-get-field (car x4) 1))
                           '()))
                   (staticfail1040)))
                (else (staticfail1040)))))))))
)
(begin
  (define translate_letdef_rec_253@front
    (lambda (x1)
      (lambda (x2)
        (2-231-translate_letdef_rec_253@front x1 x2))))
 (define 2-231-translate_letdef_rec_253@front
    (lambda (x1 x2)
      (let ((x3 (caml-constr-get-field
                  (cell-ref defined_module_128@modules)
                  0)))
        (let* ((handler-top1042 current_handler)
               (:-d.1043 (unspecified)))
          (labels
            ((try1045
               (:-d.1043)
               (begin
                 (get-the-continuation :-d.1043)
                 (if (eq? #t #f) (try1045 (try1045 (try1045 1))))
                 (if :-d.1043
                   ((make_sequence_247@front
                      (lambda (x4)
                        (labels
                          ((staticfail1044
                             ()
                             (raise 'complicated_definition_2@front)))
                          (case (if (caml-constant-constr?
                                      (caml-constr-get-field
                                        (caml-constr-get-field x4 0)
                                        0))
                                  -1
                                  (caml-regular-constr-tag
                                    (caml-constr-get-field
                                      (caml-constr-get-field x4 0)
                                      0)))
                            ((2)
                             (case (if (caml-constant-constr?
                                         (caml-constr-get-field
                                           (caml-constr-get-field x4 1)
                                           0))
                                     -1
                                     (caml-regular-constr-tag
                                       (caml-constr-get-field
                                         (caml-constr-get-field x4 1)
                                         0)))
                               ((8)
                                (caml-make-regular
                                  (caml-make-tag 6 19)
                                  2
                                  (caml-make-regular
                                    (caml-make-tag 2 38)
                                    1
                                    (caml-make-regular
                                      (caml-make-tag 0 0)
                                      2
                                      x3
                                      (caml-constr-get-field
                                        (caml-constr-get-field
                                          (caml-constr-get-field x4 0)
                                          0)
                                        0)))
                                  (cons (translate_expression_98@front
                                          (caml-constr-get-field x4 1))
                                        '())))
                               (else (staticfail1044))))
                            (else (staticfail1044))))))
                    x2)
                   current_handler))))
            (let ((x4 (try1045 :-d.1043)))
              (set! current_handler handler-top1042)
              (if (=fx *try* 1)
                (begin
                  (set! *try* 0)
                  (labels
                    ((staticfail1046 () (raise x4)))
                    (case (caml-extensible-constr-tag x4)
                      ((complicated_definition_2@front)
                       (let ((x5 (lambda (x5)
                                   (labels
                                     ((staticfail1047
                                        ()
                                        (illegal_letrec_pat_53@ty_error
                                          (caml-constr-get-field
                                            (caml-constr-get-field x5 0)
                                            1))))
                                     (case (if (caml-constant-constr?
                                                 (caml-constr-get-field
                                                   (caml-constr-get-field x5 0)
                                                   0))
                                             -1
                                             (caml-regular-constr-tag
                                               (caml-constr-get-field
                                                 (caml-constr-get-field x5 0)
                                                 0)))
                                       ((2)
                                        (caml-make-regular
                                          (caml-make-tag 6 19)
                                          2
                                          (caml-make-regular
                                            (caml-make-tag 2 38)
                                            1
                                            (caml-make-regular
                                              (caml-make-tag 0 0)
                                              2
                                              x3
                                              (caml-constr-get-field
                                                (caml-constr-get-field
                                                  (caml-constr-get-field x5 0)
                                                  0)
                                                0)))
                                          (cons (caml-make-regular
                                                  (caml-make-tag 6 19)
                                                  2
                                                  (caml-make-regular
                                                    (caml-make-tag 3 38)
                                                    1
                                                    (size_of_expr_51@front
                                                      (caml-constr-get-field
                                                        x5
                                                        1)))
                                                  '())
                                                '())))
                                       (else (staticfail1047)))))))
                         (let ((x6 ((make_sequence_247@front x5) x2)))
                           (let ((x7 (lambda (x7)
                                       (labels
                                         ((staticfail1048
                                            ()
                                            (fatal_error_193@misc
                                              #"translate_letdef_rec")))
                                         (case (if (caml-constant-constr?
                                                     (caml-constr-get-field
                                                       (caml-constr-get-field
                                                         x7
                                                         0)
                                                       0))
                                                 -1
                                                 (caml-regular-constr-tag
                                                   (caml-constr-get-field
                                                     (caml-constr-get-field
                                                       x7
                                                       0)
                                                     0)))
                                           ((2)
                                            (caml-make-regular
                                              (caml-make-tag 6 19)
                                              2
                                              (caml-make-tag 4 38)
                                              (cons (caml-make-regular
                                                      (caml-make-tag 6 19)
                                                      2
                                                      (caml-make-regular
                                                        (caml-make-tag 1 38)
                                                        1
                                                        (caml-make-regular
                                                          (caml-make-tag 0 0)
                                                          2
                                                          x3
                                                          (caml-constr-get-field
                                                            (caml-constr-get-field
                                                              (caml-constr-get-field
                                                                x7
                                                                0)
                                                              0)
                                                            0)))
                                                      '())
                                                    (cons (translate_expression_98@front
                                                            (caml-constr-get-field
                                                              x7
                                                              1))
                                                          '()))))
                                           (else (staticfail1048)))))))
                             (let ((x8 ((make_sequence_247@front x7) x2)))
                               (caml-make-regular
                                 (caml-make-tag 13 19)
                                 2
                                 x6
                                 x8))))))
                      (else (staticfail1046)))))
                x4)))))))
)
